import java.awt.*;
import java.util.*;
import java.io.*;
import java.lang.*;

public class Courbe {
	double xmin,ymin,xmax,ymax,width,height,x0,y0,facx,facy,buf;
	int[] xg, yg;
	double[] x, y;
	int imax, nemax, nfmax, nbd;
	int i0,j0,x3,y3,x4,y4,i1,j1;
	String filename;
	int pb[], tri[][], itm[][], pseg[][], tseg[][];
	int nmit[], imit[], tmit[];
	int nfbd, fbd[];
	int nxp, nyp, nxc, nyc;
	int xc,yc; 
	private Vector result;
	private static Color[] colors= {
	Color.white, Color.red, Color.yellow, Color.orange,
	Color.pink, Color.green, Color.cyan, Color.pink, Color.magenta,
	Color.blue};
	private double[][] parazoom, parabuf;
	private int nzoom=0;
    private int current=-1;
    private int nsquares=0;
    private Point[] square = new Point[100];
    private static final int SQUARELENGTH=10;
    private int pclick[],pnodebdy[][];


	public Courbe() {
	}
	
	public Vector zoom(int x1, int y1, int x2, int y2, int width1, int
	height1, int dzoom ) {
		double facmin;
	
		nxp=width1;
		nyp=height1;
		nxc=nxp/2;
		nyc=nyp/2;
		i0 = nxc;
		j0 = nyc;

		x3 = Math.min( x1, x2 );
		y3 = Math.min( y1, y2 );
		x4 = Math.max( x1, x2 );
		y4 = Math.max( y1, y2 );
		i1 = x4 - x3;
		j1 = y4 - y3;

		if (i1 == 0) {
			nzoom=1;
			this.initsize();
		}
		else if (dzoom > 0) {
			 nzoom++;
			 this.increasesize();
		}
		else if (dzoom < 0) {
			 nzoom--;
			 if (nzoom==0) {
				nzoom=1;
				this.initsize();
			}
			else {
			 	x0=parazoom[nzoom-1][0];
			 	y0=parazoom[nzoom-1][1];
			 	facx=parazoom[nzoom-1][2];
			 	facy=parazoom[nzoom-1][3];
			}
		}

		for (int i=0; i< imax; i++) {
			buf =  facx * (x[i] - x0);
		      xg[i] = (int)buf + i0;
			buf = -facy * (y[i] - y0);
		      yg[i] = (int)buf + j0;
		}


		result = new Vector();
		Integer ii = new Integer(i0);
		Integer jj = new Integer(j0);
		result.add(ii);
		result.add(jj);
		Double facxx = new Double(facx);
		Double facyy = new Double(facy);
		result.add(facxx);
		result.add(facyy);
		Double xc = new Double(x0);
		Double yc = new Double(y0);
		result.add(xc);
		result.add(yc);

		return result;
	}

	public void initsize() {
		int i,j;
		double facmin;

		x0 = 0.5 * ( xmin + xmax );
		y0 = 0.5 * ( ymin + ymax );
		width  =  xmax - xmin;
		height =  ymax - ymin;
		facx = (double)nxp /width;
		facy = (double)nyp /height;
		facx *=0.9;
		facy *=0.9;
		facmin = Math.min( facx, facy );
		facx = facmin;
		facy = facmin;

		parazoom=new double[nzoom][4];
		parazoom[nzoom-1][0]=x0;
		parazoom[nzoom-1][1]=y0;
		parazoom[nzoom-1][2]=facx;
		parazoom[nzoom-1][3]=facy;
	}

	public void increasesize() {
		int i,j;
		double facmin;

		xc=(x3+x4)/2-i0;
		yc=(y3+y4)/2-j0;
		x0 =  (double)(xc)/facx + x0;
		y0 = -(double)(yc)/facx + y0;
		
		facx = facx * (double)nxp / ( i1 );
		facy = facy * (double)nyp / ( j1 );
		facmin = Math.min( facx, facy );
		facx = facmin;
		facy = facmin;

		parabuf=new double[nzoom][4];
		for (i=0; i<nzoom-1; i++) {
		 for (j=0; j<4; j++) {
		 	parabuf[i][j]=parazoom[i][j];
		 }
		}
		parazoom=new double[nzoom][4];
		for (i=0; i<nzoom-1; i++) {
		 for (j=0; j<4; j++) {
		 	parazoom[i][j]=parabuf[i][j];
		 }
		}
		parazoom[nzoom-1][0]=x0;
		parazoom[nzoom-1][1]=y0;
		parazoom[nzoom-1][2]=facx;
		parazoom[nzoom-1][3]=facy;
	}

	public void dessine(Graphics g) {
		int i,i1,i2;
		int flag;
		for (i=0; i< nfmax; i++) {
		    i1=pseg[i][0];
		    i2=pseg[i][1];
		    flag=pb[i];
		    g.setColor(colors[flag]);
		    g.drawLine( xg[i1], yg[i1], xg[i2], yg[i2] );
		}
	}

	public void selection(int bdyflag) {
		int i, face;
		for (i=0; i< nfbd; i++) {
		    if (pclick[i] == 1) {
		      face = fbd[i]; pb[face]=bdyflag; pclick[i]=0;
		    }
		}
	}

	public void UnSelection() {
		int i, face;
		for (i=0; i< nfbd; i++) {
		    if ( pclick[i]==1 ) {face = fbd[i]; pb[face]=1;}
		}
	}

	public void findClicked1(int x1, int y1) {
		int i, i1, i2, face;
		int xm, ym, x2, y2;
		int xclose, yclose, close=5;
		double xd,yd;
		for (i=0; i< nfbd; i++) {
		    face = fbd[i];
		    i1=pseg[face][0];
		    i2=pseg[face][1];
		    xm = (xg[i1]+xg[i2])/2;
		    ym = (yg[i1]+yg[i2])/2;
		    x2 = Math.abs(xm-x1);
		    y2 = Math.abs(ym-y1);
		    xclose=Math.abs(xg[i1]-xg[i2]);
		    yclose=Math.abs(yg[i1]-yg[i2]);
		    xd = (double) xclose; yd = (double) yclose;
		    close = (int) Math.sqrt(xd*xd+yd*yd)/4;
		    if ( x2 < close && y2 < close ) { 
		       if (pclick[i] != 1) pclick[i] = 1;
 		       else pclick[i] = 0;
		    }
		}
	}

	public void findClicked2(int x1, int y1, int x2, int y2) {
		int i, i1, i2, face;
		int xm, ym;
		x3 = Math.min( x1, x2 );
		y3 = Math.min( y1, y2 );
		x4 = Math.max( x1, x2 );
		y4 = Math.max( y1, y2 );
		for (i=0; i< nfbd; i++) {
		    face = fbd[i];
		    i1=pseg[face][0];
		    i2=pseg[face][1];
		    xm = (xg[i1]+xg[i2])/2;
		    ym = (yg[i1]+yg[i2])/2;
		    if ( xm > x3 && xm < x4 
		      && ym > y3 && ym < y4 ) pclick[i] = 1;
		}
	}

	public void SelectClicked() {
		int i, i1, i2, face;
		int xm, ym;
		nsquares=0;
		for (i=0; i< nfbd; i++) {
		    if (pclick[i] == 1) {
		        face = fbd[i];
		    	i1=pseg[face][0];
		    	i2=pseg[face][1];
		    	xm = (xg[i1]+xg[i2])/2;
		    	ym = (yg[i1]+yg[i2])/2;
                        square[nsquares]=new Point(xm,ym);
			nsquares++;
	            }
		}
	}

	public void drawClicked(Graphics g) {
		int i;
		for (i=0; i< nsquares; i++) {
		    g.setColor(Color.red);
          	    g.drawRect(square[i].x - SQUARELENGTH /2,
                     square[i].y - SQUARELENGTH /2,
                     SQUARELENGTH,SQUARELENGTH);
		}
	}

	public void fact() {
		
		xmin = x[1];
		ymin = y[1];
		xmax = x[1];
		ymax = y[1];

		for (int i=0; i< imax; i++) {
			xmin = Math.min( xmin, x[i] );
			ymin = Math.min( ymin, y[i] );
			xmax = Math.max( xmax, x[i] );
			ymax = Math.max( ymax, y[i] );
		}
	}

   	public void ReadMesh(String filename){
	        StringTokenizer st;
		DataInputStream input;
 		String line;
		int i = -1;
		int j;

// read the point location from the mesh file

		try{ 
// first read the number of points
             	    input = new DataInputStream(
                    new FileInputStream(filename) );
		    line = input.readLine();
		    st = new StringTokenizer(line," ");
		    imax  = Integer.parseInt (st.nextToken());
		    nemax = Integer.parseInt (st.nextToken());
// then allocate memory
		    x = new double[imax];
		    y = new double[imax];
		    xg = new int[imax];
		    yg = new int[imax];
		    tri = new int[nemax][3];
// then read the point positions
	            for ( i=0; i<imax; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      j    = Integer.parseInt (st.nextToken());
		      x[i] = Double.parseDouble (st.nextToken());
		      y[i] = Double.parseDouble (st.nextToken()) ;
	            }
		    System.out.println(imax+" points read with success");
// then read the connection
	            for ( i=0; i<nemax; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      j         = Integer.parseInt (st.nextToken());
		      tri[i][0] = Integer.parseInt (st.nextToken());
		      tri[i][1] = Integer.parseInt (st.nextToken());
		      tri[i][2] = Integer.parseInt (st.nextToken());
		      for (j=0; j<3; j++) tri[i][j]--;
 	            }
		    System.out.println(nemax+" triangles read with success");
		    input.close();
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	   System.exit(1);
        	}

	}


// read the segment flag from a bel file

   	public void ReadBel(String filename){
	        StringTokenizer st;
		DataInputStream input;
 		String line;
		int i = -1;
		int j, i1,i2,face1,face2;

		try{ 
             	    input = new DataInputStream(
                    new FileInputStream(filename) );
	            for ( i=0; i<nfbd; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      j    = Integer.parseInt (st.nextToken());
		      i1    = Integer.parseInt (st.nextToken());
		      i2    = Integer.parseInt (st.nextToken());
		      i1--; i2--;
		      face1=pnodebdy[i1][1];
		      face2=pnodebdy[i2][0];
		      if (face1==face2)
		      pb[face1] = Integer.parseInt (st.nextToken());
	            }
		    System.out.println(nfbd+" segments read with success");
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	   System.exit(1);
        	}
	}

   	public void SaveCourbe(String filename){
		int i,j=0,i1,i2;
		int face, flag;
		
		try{ 
             	    PrintStream output = new PrintStream(
                    new FileOutputStream(filename) );
		    for (i=0; i<nfbd;i++) {
		      face = fbd[i];
		      flag = pb[face];
		      if (flag>0) {
		      	    j++;
		    	    i1=pseg[face][0]+1;
		    	    i2=pseg[face][1]+1;
			    output.println(i+"  "+i1+" "+i2+"  "+flag);
		      }
		    }
		    j++;
		    System.out.println(j+" faces saved with success");
		    output.close();
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	}

	}

	public void maille() {
  		int[] ndeb, nfin;
  		int i,j,ind,k,tk,ik,lk,pj,it,ne1,ne2,ne3,
      			i1,i2,nc,nd,buf,j1,j2;
  		int trouve;
  		int ideb,ifin;
		int nftrdim=10;

		ndeb = new int[imax+1];
		nfin = new int[imax+1];
		pseg = new int[3*imax][2];
		tseg = new int[3*imax][2];
  		nmit = new int[imax+1];
  		tmit = new int[nftrdim*imax];
  		imit = new int[nftrdim*imax];
		itm = new int[nemax][3];

  		for (i=0; i<3*imax; i++) {
	   	tseg[i][0]=-1;
	   	tseg[i][1]=-1;
  		}

/*c
c triangles (elements) mitoyens d'un noeud
c on suppose que chaque noeud est entoure de nftrdim quadrilateres
c et on remplit les vecteurs tmit et imit
c*/
      ndeb[0]=0;
      nfin[0]=0;
      for (i=0; i<imax-1; i++) {
           ndeb[i+1]=ndeb[i]+nftrdim;
           nfin[i+1]=ndeb[i+1];
      }

      for (i=0; i<nemax; i++) {
           for (k=0; k<3; k++) {
              ne1 = tri[i][k];
              ind = nfin[ne1];
              tmit[ind] = i;
              imit[ind] = k;
              nfin[ne1] = ind+1;
	      if ( ne1 < imax-1 ) {
              while ( nfin[ne1] == ndeb[ne1+1] ) {
                 ne1++;
                 for (j1=nfin[ne1]-1; j1>=ndeb[ne1]; j1--) {
                    tmit[j1+1] = tmit[j1];
                    imit[j1+1] = imit[j1];
                 }
                 ndeb[ne1]++;
                 nfin[ne1]++;
              }
              }
	   }
      }
/*c
c elimination des vides laisses dans tmit et imit
c*/
       ind=-1;
       for (i=0; i<imax; i++) {
           for (j=ndeb[i]; j<=nfin[i]-1; j++) {
               ind++;
               tmit[ind] = tmit[j];
               imit[ind] = imit[j];
           }
       }
       nmit[0]=0;
       for (i=0; i<imax; i++) {
           nmit[i+1] = nmit[i] + nfin[i] - ndeb[i];
       }

/* --------------------------
   find the faces of the mesh
   -------------------------*/

      nfmax = -1;
      for (i=0; i<nemax; i++) {
         for (j=0; j<3; j++) {
            ne1=tri[i][j];
            if (j == 2) {
	    	ne2 = tri[i][0]; }
   	    else {
	        ne2 = tri[i][j+1];
	    }
/*c
c   checker les anciennes faces des elements mitoyens
c*/
            k = nmit[ne2];
            tk = tmit[k];
            trouve = 1;
            ik = imit[k];            
            while(tk < i && trouve == 1) {
              if (ik == 2) {
	    	ne3 = tri[tk][0]; }
   	      else {
	        ne3 = tri[tk][ik+1];
	      }
               if (ne1 == ne3) {
                  lk = itm[tk][ik];
                  tseg[lk][1] = i;
                  itm[i][j] = lk;
                  trouve = 0;
               }
               k++;
               tk = tmit[k];
               ik = imit[k];           
            }
/*c
c la face est nouvelle!
c*/
            if (trouve == 1) {
               nfmax++;
               itm[i][j] = nfmax;
               tseg [nfmax] [0] = i;
               pseg [nfmax] [0] = ne1;
               pseg [nfmax] [1] = ne2;
            }
         }      
      }
      nfmax++;
      pb = new int[nfmax];
      for (i=0; i<nfmax; i++) pb[i] = 0;


// ************* find the boundary faces ************* //

      nfbd=0;
      for (i=0; i<nfmax; i++) {
          if (tseg[i][1]==-1) nfbd++;
      }
      fbd = new int[nfbd];
      pclick = new int[nfbd];
      pnodebdy= new int[imax][2];
      
      j=-1;
      for (i=0; i<nfmax; i++) {
          i1 = pseg[i][0];
	  i2 = pseg[i][1];
          if (tseg[i][1]==-1) {
	  j++;
	  fbd[j]=i;
	  pb[i]=1;
	  pclick[j]=0;
	  pnodebdy[i1][1]=i;
	  pnodebdy[i2][0]=i;
	  }
      }
      
}

   	public void ProjStr(){
		int i;
		double r,ang;
		for (i=0; i<imax; i++) {
		    ang = y[i];
		    ang *= Math.PI/180;
		    r = Math.cos(ang)/( 1.0 + Math.sin(ang) );
		    ang=x[i];
		    ang *= Math.PI/180;
		    x[i]= r * Math.cos(ang);
		    y[i]= r * Math.sin(ang);
		}
	}

}
