import java.applet.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class SpecifyBc extends Frame {
	Button boutonS, boutonL, boutonF1, boutonF2, boutonQ, 
	boutonZ, boutonDZ, boutonRD, boutonL1, boutonP1;
	FileDialog file_dialog;
	String filename;
	String dirname;
	String flagname;
	int bdyflag;
	Courbe co;
	int npoint;
	BarreEtat etat;
	zGra graphique;
	Vector recup;
	int x1,y1,x2,y2,x3,y3,i0,j0,drag;
	double facx,facy,xx,yy,x0,y0;
	TextField textfield;
	int width=500, height=600;
	private int nzoom, lire=0;

	public SpecifyBc(String name) {
	        dirname = new String(name);
		Panel tools;
	        setTitle("Boundary Tagger");
		setSize(width, height);
		setBackground(Color.lightGray);
		setBackground(Color.lightGray);
		tools = new Panel();
		tools.setLayout(new GridLayout(2,7));
	        boutonS = new Button("Save");
	        boutonL = new Button("Read Mesh");
	        boutonL1 = new Button("Read Bel");
	        boutonF1 = new Button("UnSelect");
 	        boutonF2 = new Button("Select");
	        boutonZ = new Button("Zoom");
 	        boutonDZ = new Button("unZoom");
 	        boutonRD = new Button("reDraw");
 	        boutonP1 = new Button("Projection");
	        boutonQ = new Button("Quitter");
		textfield = new TextField("1", 5);
		tools.add(boutonL);
		tools.add(boutonL1);
		tools.add(boutonS);
		tools.add(boutonF1);
		tools.add(boutonF2);
		tools.add(boutonZ);
		tools.add(boutonDZ);
		tools.add(boutonRD);
		tools.add(boutonP1);
		tools.add(boutonQ);
		tools.add(new Label("Bdy Flag"));
		tools.add(textfield);
		etat = new BarreEtat();
		this.setLayout(new BorderLayout(3,1));
		this.add(tools,"North");
		co = new Courbe();
		this.add(graphique = new zGra(etat, co),"Center");
		this.add(etat,"South");
//		this.pack();
		this.show();
	}
	public boolean action(Event e, Object What){

		if (e.target == boutonQ){
			this.hide();
			this.dispose();
			System.exit(0);
			return true;
		}
		else if (e.target == boutonL){
			file_dialog = new FileDialog(this, "Open File", 
			FileDialog.LOAD);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			System.out.println("read: "+filename);
			co.ReadMesh(filename);
			co.maille();
			co.fact();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			lire=1;
			return true;
		}
		else if (e.target == boutonL1){
		  if (lire==1) {
			file_dialog = new FileDialog(this, "Open File", 
			FileDialog.LOAD);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			System.out.println("read: "+filename);
			co.ReadBel(filename);
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			return true;
		   }
		   else  etat.afficheMessage( "read mesh first" );

		}
		else if (e.target == boutonP1){
			co.ProjStr();
			co.fact();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			lire=1;
			return true;
		}
		else if (e.target == boutonZ){
		        drag=graphique.dragged();
			if (drag==1) {
			recup = new Vector(graphique.newZoom());
			recup2();
			Dimension d=graphique.size();
			recup= new Vector(co.zoom(x1, y1, x2, y2, d.width,
			d.height, 1));
			recupere();
			graphique.puttoback();
           		etat.afficheMessage( "Zoom done" );
			}
			else etat.afficheMessage( "Rect too small" );
			return true;
		}
		else if (e.target == boutonDZ){
			Dimension d=graphique.size();
			recup= new Vector(co.zoom(0, 0, 1, 1, d.width, d.height,
			-1));
			recupere();
			graphique.puttoback();
           		etat.afficheMessage( "unZoom done" );
			return true;
		}
		else if (e.target == boutonRD){
			Dimension d=graphique.size();
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
			graphique.puttoback();
           		etat.afficheMessage( "reDraw done" );
			return true;
		}
		else if (e.target == boutonF2){
		        drag=graphique.dragged();
			flagname= new String(textfield.getText());
			bdyflag= Integer.parseInt(flagname);
			if (drag==1) {
			recup = new Vector(graphique.newZoom());
			recup2();
		        co.findClicked2(x1, y1, x2, y2);
			}
			co.selection(bdyflag);
			graphique.puttoback();
           		etat.afficheMessage( "Select done" );
			return true;
		}
		else if (e.target == boutonF1){
			recup = new Vector(graphique.newZoom());
			recup2();
			co.UnSelection();
			graphique.puttoback();
           		etat.afficheMessage( "Select done" );
			return true;
		}
		else if (e.target == boutonS){
			file_dialog = new FileDialog(this, "Save As", 
			FileDialog.SAVE);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			co.SaveCourbe(filename);
			System.out.println("save: "+filename);
			return true;
		}
		return false;
	}

	public static void main(String args[]) {
		new SpecifyBc(args[0]);
	}

	public void recupere() {
		String ci;

		ci = recup.get(0).toString();
		i0 = Integer.parseInt(ci);
		ci = recup.get(1).toString();
		j0 = Integer.parseInt(ci);
		ci = recup.get(2).toString();
		facx = Double.parseDouble(ci);
		ci = recup.get(3).toString();
		facy = Double.parseDouble(ci);
 		ci = recup.get(4).toString();
		x0 = Double.parseDouble(ci);
 		ci = recup.get(5).toString();
		y0 = Double.parseDouble(ci);
	}
	public void recup2() {
		x1 = Integer.parseInt(recup.get(0).toString());
		y1 = Integer.parseInt(recup.get(1).toString());
		x2 = Integer.parseInt(recup.get(2).toString());
		y2 = Integer.parseInt(recup.get(3).toString());
	}


}
